#!/usr/bin/env python
# -*- coding: utf-8 -*-

##
## Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##

import os
import dbus
import urllib
import ConfigParser
from subprocess import Popen, PIPE
import sys, apt, tempfile, gettext
from subprocess import Popen, PIPE

from PyQt4.QtGui import *
from PyQt4.QtCore import *
from dialog import Ui_dialog, _fromUtf8, _translate

SERVER = "cdos1.os.cn:8888/cdos-upgrade"

origin_manifest = {}
new_manifest = {}
cur_manifest = {}
is_updateing = False

QTextCodec.setCodecForTr(QTextCodec.codecForName("utf8"))

def networkBroken(QWidget):
    install_plugin = QMessageBox.warning(QWidget, _translate("dialog", "网络异常", None), 
                                         _translate("dialog", "网络未连接，请连接网络后重试", None),
                                         buttons=QMessageBox.Ok,
                                         defaultButton=QMessageBox.NoButton)
    sys.exit(1)

def reboot():
    bus = dbus.SystemBus()
    bus_obj = bus.get_object("org.cdosupgrade","/org/cdosupgrade")
    iface = dbus.Interface(bus_obj, "org.cdosupgrade")
    try:
        iface.cdos_reboot()
    except dbus.exceptions.DBusException:
        print "reboot exception"
        sys.exit(1)

class Widget(QWidget):
    
    def __init__(self,parent=None):
        self.upgrade_flag = False
        super(Widget, self).__init__(parent)
        self.ui = Ui_dialog()
        self.ui.setupUi(self)
        #self.setWindowIcon(QIcon("/usr/share/icons/hicolor/scalable/categories/cs-cdosupgrade.svg"))
        #self.setWindowTitle(_translate("dialog", "系统升级", None))
        self.setWindowTitle(self.tr("系统升级"))
        #self.setWindowFlags(Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint)
        self.setWindowFlags(Qt.WindowMinimizeButtonHint | Qt.WindowCloseButtonHint)
        self.setFixedSize(self.width(), self.height())
        desktop = QApplication.desktop()
        self.move((desktop.width() - self.width())/2, (desktop.height() - self.height())/2)  
        

        self.connect(self.ui.button1, SIGNAL('clicked()'), self.button1_clicked)
        self.connect(self.ui.button2, SIGNAL('clicked()'), self.button2_clicked)
        self.connect(self.ui.button3, SIGNAL('clicked()'), self.button3_clicked)
        
        self.connect(self.ui.radioButton_net, SIGNAL('clicked(bool)'),self.radioChange )
        self.connect(self.ui.radioButton_upan, SIGNAL('clicked(bool)'),self.radioChange )
        
        self.connect(self.ui.stackedWidget, SIGNAL('currentChanged(int)'),self.pageChanged)
        self.ui.stackedWidget.setCurrentIndex(1)
        self.ui.listWidget.clear()
        
        self.new_release = ''
        self.cur_release = ''
        self.page2show()
        #if self.check_need_update():
        #    self.page2show()
        #    pass
        #else:
        #    self.noUpgradePageShow()
        #    pass

        self.backup_flag = False
        
        qssFile =QFile(":/qss/my.qss")
        qssFile.open(QFile.ReadOnly)
        styleSheet = qssFile.readAll()
        styleSheet = unicode(styleSheet, encoding = 'utf8')
        self.setStyleSheet(styleSheet)        
        
    
    def noUpgradePageShow(self):
        self.ui.label_info.hide()
        self.ui.label_msg.setText(_translate("dialog", "当前已是最新版本，无需升级", None))
        self.ui.button1.show()
        self.ui.button2.hide()
        self.ui.button3.hide()
        self.ui.button1.setObjectName(_fromUtf8("exitButton"))
        self.setStyleSheet(self.styleSheet())        
        pass
        
    def page1show(self):
        #self.ui.button1.hide()
        if self.upgrade_flag:
            self.ui.label_info.hide()
            self.ui.label_msg.setText(_translate("dialog", "升级已完成，是否重启?", None))
            #self.ui.button2.setObjectName(_fromUtf8("backButton"))
            self.ui.button1.setObjectName(_fromUtf8("cancelButton"))
            self.ui.button3.setObjectName(_fromUtf8("rebootButton"))
            #self.ui.button1.setObjectName(_fromUtf8("exitButton"))
            self.ui.button2.hide()
            self.setStyleSheet(self.styleSheet())
            #self.ui.button2.setStyleSheet(_fromUtf8("background-image: url(:/image/image/next_upgrade.png);"))
            #self.ui.button3.setStyleSheet(_fromUtf8("background-image: url(:/image/image/right_upgrade.png);"))
            self.ui.button3.setDisabled(False)
        else:
            self.ui.label_info.setText(_translate("dialog", "检测到新版本%s" %self.new_release, None))
            self.ui.label_msg.setText(_translate("dialog", "当前系统版本%s" %self.cur_release, None))
            self.ui.button2.setObjectName(_fromUtf8("backButton"))
            self.ui.button3.setObjectName(_fromUtf8("nextStepButton"))
            #self.ui.button1.setObjectName(_fromUtf8("exitButton"))
            self.ui.button2.show()
            self.setStyleSheet(self.styleSheet())
            #self.ui.button2.setStyleSheet(_fromUtf8("background-image: url(:/image/image/next_upgrade.png);"))
            #self.ui.button3.setStyleSheet(_fromUtf8("background-image: url(:/image/image/right_upgrade.png);"))
            self.ui.button3.setDisabled(False)
        
    def page2show(self):
        self.ui.radioButton_net.setChecked(True)
        self.ui.radioButton_upan.hide()
        self.ui.label_7.hide()
        self.ui.button2.hide()
        #self.ui.radioButton_upan.setChecked(False)
        self.ui.button1.setObjectName(_fromUtf8("exitButton"))
        #self.ui.button2.setObjectName(_fromUtf8("backButton"))
        self.ui.button3.setObjectName(_fromUtf8("nextStepButton"))
        self.setStyleSheet(self.styleSheet())
        self.ui.button1.show()
        #self.ui.button2.setStyleSheet(_fromUtf8("background-image: url(:/image/image/back.png);"))
        #self.ui.button3.setStyleSheet(_fromUtf8("background-image: url(:/image/image/right_upgrade.png);"))
        self.ui.button3.setDisabled(not (self.ui.radioButton_net.isChecked() or self.ui.radioButton_upan.isChecked()))   
        pass
    
    def page3show(self):
        self.ui.button1.setObjectName(_fromUtf8("exitButton"))
        self.ui.button1.show()
        self.ui.label_8.setText(_translate("dialog", "如下软件包是原版本系统中额外安装的包，升级到%s后不能保证100%%可用" %self.new_release, None))
        self.ui.button2.setObjectName(_fromUtf8("backButton"))
        self.ui.button3.setObjectName(_fromUtf8("nextStepButton"))
        self.setStyleSheet(self.styleSheet())
        #self.ui.button3.setStyleSheet(_fromUtf8("background-image: url(:/image/image/update.png);"))
        pass
    
    def page4show(self):
        #self.ui.button1.setObjectName(_fromUtf8("backButton"))
        #self.ui.button2.setObjectName(_fromUtf8("nobackupButton"))
        self.ui.button1.setObjectName(_fromUtf8("nobackupButton"))
        self.ui.button2.setObjectName(_fromUtf8("backButton"))
        self.ui.button3.setObjectName(_fromUtf8("backupButton"))
        self.setStyleSheet(self.styleSheet())
        self.ui.button1.show()
        #self.ui.button3.setStyleSheet(_fromUtf8("background-image: url(:/image/image/backup.png);"))
        #self.ui.button2.setStyleSheet(_fromUtf8("background-image: url(:/image/image/nonbackup.png);"))
        pass

    def pageChanged(self,index):
        if index == 0:
            self.page1show()
        elif index == 1:
            self.page2show()
        elif index == 2:
            self.page3show()
        else:
            self.page4show()
            
    def button3_clicked(self):
        index = self.ui.stackedWidget.currentIndex()
        if index == 0:
            #self.ui.stackedWidget.setCurrentIndex(1)
        #elif index == 1:
            #listWidget添加内容
            if self.upgrade_flag:
                reboot()
            else:
                self.ui.listWidget.clear()
                self.show_third_party_package()
                self.ui.stackedWidget.setCurrentIndex(2)
        elif index == 2:
            #确定更新
            self.ui.stackedWidget.setCurrentIndex(3)
        elif index == 3:
            self.backup_flag = True
            self.update_system()
            self.show()
            self.upgrade_flag = True
            self.ui.stackedWidget.setCurrentIndex(0)
        elif index == 1:
            if self.check_need_update():
                self.ui.stackedWidget.setCurrentIndex(0)
                self.page1show()
            else:
                self.ui.stackedWidget.setCurrentIndex(0)
                self.noUpgradePageShow()           
            
    
    def button2_clicked(self):
        index = self.ui.stackedWidget.currentIndex()
        if index == 0:
            self.ui.stackedWidget.setCurrentIndex(index + 1)
        elif index == 3:
            self.ui.stackedWidget.setCurrentIndex(index - 1)
        else:
            self.ui.stackedWidget.setCurrentIndex(index - 2)
            

    def button1_clicked(self):
        index = self.ui.stackedWidget.currentIndex()
        if index == 3:
            #self.ui.stackedWidget.setCurrentIndex(index -1)
            self.backup_flag = False
            self.update_system()
            self.show()
            self.upgrade_flag = True
            self.ui.stackedWidget.setCurrentIndex(0)
        else:
            qApp.quit() 
    
            
    def radioChange(self,b):
        self.ui.button3.setDisabled(False)
        pass
    
    def check_need_update(self):
        new_release_file = "http://%s/upgrade.cfg" % SERVER
        local_conf_dir = os.path.join(os.getenv("HOME"), ".config/cdosupgrade/")
        if not os.path.exists(local_conf_dir):
            os.mkdir(local_conf_dir)
        local_conf_file = os.path.join(os.getenv("HOME"), ".config/cdosupgrade/upgrade.cfg")
        conf = ConfigParser.ConfigParser(defaults=None)
        try:
            urllib.urlretrieve(new_release_file,local_conf_file)
        except:
            networkBroken(self)
        conf.read(local_conf_file)
        new_release = conf.get("lastest", "OS_VERSION")
        with open ("/etc/os-release") as f:
            for line in f.readlines():
                if line.startswith("VERSION="):
                    cur_release = eval(line.split("=")[-1].strip("\n"))
        self.cur_release = cur_release
        self.new_release = new_release
        return self.compare_version()
    
    def compare_version(self):
        #cur_release_num = self.cur_release.split('-')[0]
        #new_release_num = self.new_release.split('-')[0]
        #if new_release_num > cur_release_num:
        #    return True
        #elif new_release_num < cur_release_num:
        #    return False
        try:
            cur_release_date = self.cur_release.split('-')[2]
            new_release_date = self.new_release.split('-')[2]
        except:
            return True
        if not cur_release_date.isdigit():
            return True      
        if new_release_date > cur_release_date:
            return True
        else:
            return False


        
    def show_third_party_package(self):
        #获得更新包，用户自定义安装包，以及待删除的包
        custom_pkgs = self.get_update_pkgs()
        local_config_path =os.path.join(os.getenv("HOME"), ".config/cdosupgrade/")
        with open(os.path.join(local_config_path, "custom_pkgs"), "w") as f:
            f.write('\n'.join(custom_pkgs))            
        custom_pkgs = list(custom_pkgs)
        custom_pkgs.sort()
        for pkg in custom_pkgs:
            self.ui.listWidget.addItem(pkg)      
        pass
    
    def get_update_pkgs(self):
        server_path = "http://%s/%s/" %(SERVER, self.new_release)
        local_path =os.path.join(os.getenv("HOME"), ".config/cdosupgrade/")
        if not os.path.exists(local_path):
            os.makedirs(local_path,mode=0755)
        try:
            urllib.urlretrieve(server_path+"filesystem.manifest",local_path+"filesystem.manifest")
            urllib.urlretrieve(server_path+"official-package-repositories.list",local_path+"official-package-repositories.list")
            urllib.urlretrieve(server_path+"filesystem.manifest-remove",local_path+"filesystem.manifest-remove")
            urllib.urlretrieve(server_path+"os-release",local_path+"os-release")
            urllib.urlretrieve(server_path+"lsb-release",local_path+"lsb-release")
            urllib.urlretrieve(server_path+"fix_bug.py",local_path+"fix_bug.py")
        except:
            networkBroken(self)           
        origin_manifest_path = ("/var/log/installer/filesystem.manifest")
        if os.path.exists(origin_manifest_path):
            with open(origin_manifest_path) as f:
                for line in f.readlines():
                    (key, value) = line.strip("\n").split()
                    origin_manifest[key] = value
                    
        cur_manifest_path = os.path.join(os.getenv("HOME"), ".config/cdosupgrade/current.manifest")
        os.system("dpkg-query -W --showformat='${Package} ${Version}\n' > %s" % cur_manifest_path)
        with open(cur_manifest_path) as f:
            for line in f.readlines():
                (key, value) = line.strip("\n").split()
                cur_manifest[key] = value

        new_manifest_path = os.path.join(os.getenv("HOME"), ".config/cdosupgrade/filesystem.manifest")
        with open(new_manifest_path) as f:
            for line in f.readlines():
                (key, value) = line.strip("\n").split()
                new_manifest[key] = value
        custom_pkgs = []
        nhold_pkgs = []
        upgrade_pkgs = []
        if os.path.exists(origin_manifest_path):        
            custom_pkgs = set(cur_manifest.keys()) - set(origin_manifest.keys())
            nhold_pkgs = set(origin_manifest.keys()) - set(new_manifest.keys()) - custom_pkgs
        new_pkgs = set(new_manifest.keys()) - set(cur_manifest.keys())
        upgrade_pkgs = set(new_manifest.keys()) - new_pkgs
        upgrade_pkgs_version = []
        upgrade_manifest_path = os.path.join(os.getenv("HOME"), ".config/cdosupgrade/upgrade_pkgs")
        for package in upgrade_pkgs:
            if cur_manifest[package] == new_manifest[package]:
                continue
            else:
                item = "%s %s" %(package, new_manifest[package])
                upgrade_pkgs_version.append(item)
        with open(upgrade_manifest_path, 'w') as f:
            f.write('\n'.join(upgrade_pkgs_version))
            
        install_pkgs_list = []
        install_manifest_path = os.path.join(os.getenv("HOME"), ".config/cdosupgrade/new_pkgs")
        for package in new_pkgs:
            item = "%s %s" %(package, new_manifest[package])
            install_pkgs_list.append(item)
        with open(install_manifest_path, 'w') as f:
            f.write('\n'.join(install_pkgs_list))
            
        return custom_pkgs
    
    def update_system(self):
         #Turn off the screensaver during the upgrade
        screensaver_setting = None
        screensaver_enabled = "true"

        screensaver_setting = "org.cinnamon.desktop.screensaver lock-enabled"
        if screensaver_setting is not None:
            enabled = os.popen("gsettings get %s" % screensaver_setting).readlines()[0].strip()
            if enabled == "false":
                screensaver_enabled = "false"
            else:
                os.system("gsettings set %s false" % screensaver_setting)
        new_repository_list_path = os.path.join(os.getenv("HOME"), ".config/cdosupgrade/official-package-repositories.list")
        local_path = os.getenv("HOME")
        backup_flag = self.backup_flag
        print "backup_flag : %s" %backup_flag
        cmd = ["/usr/bin/cdos-release-upgrade-root", "%s" % new_repository_list_path, "%s" % local_path, "%s" % backup_flag]
        self.hide()
        comnd = Popen(' '.join(cmd), shell=True)
        returnCode = comnd.wait()
    
       

if __name__ == "__main__":
    app = QApplication(sys.argv)
    widget = Widget()
    widget.show()
    app.exec_()
