#!/usr/bin/env python
# *-* coding:utf-8 *-*

##
## Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##

import os, sys, apt, tempfile, time
from subprocess import Popen, PIPE
from window import Window


if os.getuid() != 0:
    print "Run this code as root!"
    sys.exit(1)

if len(sys.argv) != 4:
    print "Missing arguments!"
    sys.exit(1)


#STEP 1:backup system

def backup_system():
    cmd = ["sudo", "/bin/tar", " cvpzf /backup.tgz --exclude=/proc --exclude=/lost+found --exclude=/backup.tgz --exclude=/sys --exclude=/mnt --exclude=/media / &"]
    #cmd = ["sleep 3"]
    comnd = Popen(' '.join(cmd), shell=True)
    returnCode = comnd.wait()


#STEP 2: changed sources list+
#STEP 3: UPDATE APT SOURCES
#---------------------------
#sources_list = os.path.join(os.getenv("HOME"), ".config/linuxmint/official-package-repositories.list")
#sources_list = "/usr/lib/linuxmint/mintUpdate/rel_upgrades/%s/official-package-repositories.list" % codename
def update_apt_sources(sources_list):
    print "tonihutest.......22222..."
    if not os.path.exists(sources_list):
        sys.exit(1)
    if os.path.exists("/etc/apt/sources.list.d/official-source-repositories.list"):
        os.system("rm -f /etc/apt/sources.list.d/official-source-repositories.list")
    os.system("cp %s /etc/apt/sources.list.d/official-package-repositories.list" % sources_list)
    print "tonihutest.......333333..."


# STEP 4: UPDATE APT CACHE
#-------------------------

def update_apt_cache():
    cache = apt.Cache()
    from subprocess import Popen, PIPE
    #cmd = ["sudo", "/usr/sbin/synaptic", "--hide-main-window", "--update-at-startup", "--non-interactive", "--parent-window-id", "%d" % dialog.window.xid]
    cmd = ["sudo", "/usr/sbin/synaptic", "--hide-main-window", "--update-at-startup", "--non-interactive", "--parent-window-id", "%d" % 10]
    comnd = Popen(' '.join(cmd), shell=True)
    returnCode = comnd.wait()
    print "tonihutest.......4444444..."
    return cache


# STEP 5: INSTALL LEVEL 1 UPDATES
# INSTALL ALL changed updates tonihu add 
#--------------------------------

def install_updates(cache,local_path):
    dist_upgrade = True
    # Reopen the cache to reflect any updates
    cache.open(None)
    cache.upgrade(dist_upgrade)
    changes = cache.get_changes()
    #cmd = ["sudo", "/usr/sbin/synaptic", "--hide-main-window", "--non-interactive", "--parent-window-id", "%d" % dialog.window.xid]
    cmd = ["sudo", "/usr/sbin/synaptic", "--hide-main-window", "--non-interactive", "--parent-window-id", "%d" % 10]
    cmd.append("-o")
    cmd.append("Synaptic::closeZvt=true")
    cmd.append("--progress-str")
    cmd.append("\"" + _("Please wait, this can take some time") + "\"")
    cmd.append("--finish-str")
    cmd.append("\"" + _("Update is complete") + "\"")
    f = tempfile.NamedTemporaryFile()
    for pkg in changes:
        if (pkg.is_installed and pkg.marked_upgrade):
            package = pkg.name
            newVersion = pkg.candidate.version
            oldVersion = pkg.installed.version
            size = pkg.candidate.size
            sourcePackage = pkg.candidate.source_name
            short_description = pkg.candidate.raw_description
            description = pkg.candidate.description
            if (newVersion != oldVersion):
                update_type = "package"
                for origin in pkg.candidate.origins:
    #                if origin.origin == "linuxmint":
    #                    if origin.component != "romeo" and origin.component != "backport" and package != "linux-kernel-generic":
                            f.write("%s\tinstall\n" % package)
    #install new packages
    #local_config_path =os.path.join(local_path, ".config/linuxmint/")
    #with open(os.path.join(local_config_path, "new_pkgs")) as fi:
        #for line in fi.readlines():
            #f.write("%s\tinstall\n" % line.strip())
    cmd.append("--set-selections-file")
    cmd.append("%s" % f.name)
    f.flush()
    comnd = Popen(' '.join(cmd), shell=True)
    returnCode = comnd.wait()
    print "tonihutest.......55555..."


def update_release(local_path):
    new_release = os.path.join(local_path, ".config/linuxmint/lsb-release")
    if not os.path.exists(new_release):
        print "not new release"
        sys.exit(1)
    if os.path.exists("/etc/lsb-release"):
        os.system("rm -f /etc/lsb-release")
    os.system("cp %s /etc/lsb-release" % new_release)
    print "666666666666666666666666666"


def reboot():
    os.system("sudo reboot")



if __name__ == "__main__":
    app = QApplication(sys.argv)
    sources_list = sys.argv[1]
    local_path = sys.argv[2]
    backup_flag = sys.argv[3]
    window = Window()
    window.show()
    app.exec_()        
